// This code was autogenerated from socket.service.proto, do not edit.

package api

import (
	"encoding/json"
	"github.com/golang/protobuf/proto"
	"github.com/google/uuid"
	infra "gitlab.com/silenteer-oss/hestia/infrastructure"
	"gitlab.com/silenteer-oss/titan"

	goff "gitlab.com/silenteer-oss/goff"

	"sync"
	"time"
)

var _ = uuid.Nil
var _ = proto.Marshal
var _ goff.UUID
var _ json.Decoder
var _ time.Duration
var _ infra.Empty

// Type definitions
type SendToDeviceRequest struct {
	DeviceId    string              `json:"deviceId"`
	MessageInfo *SendRequestMessage `json:"messageInfo"`
}

type SendToUserRequest struct {
	UserId      *uuid.UUID          `json:"userId"`
	MessageInfo *SendRequestMessage `json:"messageInfo"`
}

type SendRequestMessage struct {
	Id            string              `json:"id"`
	Topic         Topic               `json:"topic"`
	MessageBody   string              `json:"messageBody"`
	Headers       map[string][]string `json:"headers"`
	StatusCode    int64               `json:"statusCode"`
	Subject       string              `json:"subject"`
	ResponseTopic Topic               `json:"responseTopic"`
}

type SendToPatientRequest struct {
	ExternalUserId string              `json:"externalUserId"`
	MessageInfo    *SendRequestMessage `json:"messageInfo"`
}

type MessageResponse struct {
	Id          *string             `json:"id,omitempty"`
	Topic       *Topic              `json:"topic,omitempty"`
	MessageBody *string             `json:"messageBody,omitempty"`
	Headers     map[string][]string `json:"headers,omitempty"`
	StatusCode  *int64              `json:"statusCode,omitempty"`
}

type OpenCompanionMessage struct {
	SessionId string `json:"sessionId"`
	DeviceId  string `json:"deviceId"`
}

type SendToUsersRequest struct {
	UserIds     []uuid.UUID         `json:"userIds"`
	MessageInfo *SendRequestMessage `json:"messageInfo"`
}

type SendToUsersResponse struct {
	UserIds     []uuid.UUID         `json:"userIds"`
	MessageInfo *SendRequestMessage `json:"messageInfo"`
}

type SendToCareProviderPatientsRequest struct {
	CareProviderId *uuid.UUID          `json:"careProviderId"`
	MessageInfo    *SendRequestMessage `json:"messageInfo"`
}

type SendToCareProviderMembersRequest struct {
	CareProviderId *uuid.UUID          `json:"careProviderId"`
	MessageInfo    *SendRequestMessage `json:"messageInfo"`
}

type DeviceEvent struct {
	Type           string     `json:"type"`
	TicketId       string     `json:"ticketId"`
	DeviceNumber   int64      `json:"deviceNumber"`
	PatientId      *uuid.UUID `json:"patientId"`
	CareProviderId *uuid.UUID `json:"careProviderId"`
	DeviceId       *uuid.UUID `json:"deviceId"`
	ConversationId *uuid.UUID `json:"conversationId"`
}

type SendEventToDeviceRequest struct {
	DeviceId    string       `json:"deviceId"`
	DeviceEvent *DeviceEvent `json:"deviceEvent"`
}

type SendToDeviceWithResponseRequest struct {
	DeviceId *uuid.UUID `json:"deviceId"`
	Url      string     `json:"url"`
	Body     string     `json:"body"`
}

type NatRequest struct {
	Headers map[string][]string `json:"headers"`
	Subject string              `json:"subject"`
	Method  string              `json:"method"`
	Url     string              `json:"url"`
	Body    string              `json:"body"`
}

type NatResponse struct {
	Headers    map[string][]string `json:"headers"`
	Status     string              `json:"status,reason"`
	StatusCode int32               `json:"statusCode,code"`
	Body       string              `json:"body"`
}

type SendToDeviceResponse struct {
	DeviceId *uuid.UUID `json:"deviceId"`
	JsonData string     `json:"jsonData"`
}

type NotifySocketConnCreatedRequest struct {
	UserId    string `json:"userId"`
	SessionId string `json:"sessionId"`
}

type SendToClientRequest struct {
	SessionId   string              `json:"sessionId"`
	MessageInfo *SendRequestMessage `json:"messageInfo"`
}

// enum definitions
type Topic string

const (
	PING                Topic = "PING"
	PONG                Topic = "PONG"
	CHAT                Topic = "CHAT"
	APPOINTMENT         Topic = "APPOINTMENT"
	COMMUNICATION_PLAN  Topic = "COMMUNICATION_PLAN"
	EMPLOYEE_CHANGED    Topic = "EMPLOYEE_CHANGED"
	APPOINTMENT_CHANGED Topic = "APPOINTMENT_CHANGED"
	CUSTOMER_CHANGED    Topic = "CUSTOMER_CHANGED"
)

type DeviceRequestType string

const (
	DEVICE_EXISTED       DeviceRequestType = "DEVICE_EXISTED"
	DEVICE_READY         DeviceRequestType = "DEVICE_READY"
	DEVICE_ADDED         DeviceRequestType = "DEVICE_ADDED"
	DEVICE_LOGIN         DeviceRequestType = "DEVICE_LOGIN"
	ADMIN_PAIRED_SUCCESS DeviceRequestType = "ADMIN_PAIRED_SUCCESS"
)

type UrlCompanionAction string

const (
	OpenWS UrlCompanionAction = "OpenWS"
)

// Define constants
const NATS_SUBJECT = "api.service.socket" // nats subject this service will listen to

// service event constants
const EVENT_SendEventToDevice = "api.service.socket.SocketService.SendEventToDevice"
const LEGACY_TOPIC_SendEventToDevice = "/api/service/socket/sendEventToDevice"
const EVENT_SendToDevice = "api.service.socket.SocketService.SendToDevice"
const LEGACY_TOPIC_SendToDevice = "/api/service/socket/sendToDevice"
const EVENT_SendToUser = "api.service.socket.SocketService.SendToUser"
const LEGACY_TOPIC_SendToUser = "/api/service/socket/sendToUser"
const EVENT_SendToUsers = "api.service.socket.SocketService.SendToUsers"
const LEGACY_TOPIC_SendToUsers = "/api/service/socket/sendToUsers"
const EVENT_SendToPatient = "api.service.socket.SocketService.SendToPatient"
const LEGACY_TOPIC_SendToPatient = "/api/service/socket/sendToPatient"
const EVENT_SendToCareProviderPatients = "api.service.socket.SocketService.SendToCareProviderPatients"
const LEGACY_TOPIC_SendToCareProviderPatients = "/api/service/socket/sendToCareProviderPatients"
const EVENT_SendToCareProviderMembers = "api.service.socket.SocketService.SendToCareProviderMembers"
const LEGACY_TOPIC_SendToCareProviderMembers = "/api/service/socket/sendToCareProviderMembers"
const EVENT_SendToDeviceWithResponse = "api.service.socket.SocketService.SendToDeviceWithResponse"
const LEGACY_TOPIC_SendToDeviceWithResponse = "/api/service/socket/sendToDeviceWithResponse"
const EVENT_NotifySocketConnCreated = "api.service.socket.SocketService.NotifySocketConnCreated"
const LEGACY_TOPIC_NotifySocketConnCreated = "/api/service/socket/notifySocketConnCreated"
const EVENT_SendToClient = "api.service.socket.SocketService.SendToClient"
const LEGACY_TOPIC_SendToClient = "/api/service/socket/sendToClient"

// message event constants

// Define service interface -------------------------------------------------------------
type SocketService interface {
	SendEventToDevice(ctx *titan.Context, request *SendEventToDeviceRequest) (*MessageResponse, error)
	SendToDevice(ctx *titan.Context, request *SendToDeviceRequest) (*MessageResponse, error)
	SendToUser(ctx *titan.Context, request *SendToUserRequest) (*MessageResponse, error)
	SendToUsers(ctx *titan.Context, request *SendToUsersRequest) (*SendToUsersResponse, error)
	SendToPatient(ctx *titan.Context, request *SendToPatientRequest) (*MessageResponse, error)
	SendToCareProviderPatients(ctx *titan.Context, request *SendToCareProviderPatientsRequest) (*MessageResponse, error)
	SendToCareProviderMembers(ctx *titan.Context, request *SendToCareProviderMembersRequest) (*MessageResponse, error)
	SendToDeviceWithResponse(ctx *titan.Context, request *SendToDeviceWithResponseRequest) (*SendToDeviceResponse, error)
	NotifySocketConnCreated(ctx *titan.Context, request *NotifySocketConnCreatedRequest) error
	SendToClient(ctx *titan.Context, request *SendToClientRequest) (*MessageResponse, error)
}

// Define service proxy -------------------------------------------------------------------
type SocketServiceProxy struct {
	service SocketService
}

func (srv *SocketServiceProxy) SendEventToDevice(ctx *titan.Context, request *SendEventToDeviceRequest) (*MessageResponse, error) {
	return srv.service.SendEventToDevice(ctx, request)
}
func (srv *SocketServiceProxy) SendToDevice(ctx *titan.Context, request *SendToDeviceRequest) (*MessageResponse, error) {
	return srv.service.SendToDevice(ctx, request)
}
func (srv *SocketServiceProxy) SendToUser(ctx *titan.Context, request *SendToUserRequest) (*MessageResponse, error) {
	return srv.service.SendToUser(ctx, request)
}
func (srv *SocketServiceProxy) SendToUsers(ctx *titan.Context, request *SendToUsersRequest) (*SendToUsersResponse, error) {
	return srv.service.SendToUsers(ctx, request)
}
func (srv *SocketServiceProxy) SendToPatient(ctx *titan.Context, request *SendToPatientRequest) (*MessageResponse, error) {
	return srv.service.SendToPatient(ctx, request)
}
func (srv *SocketServiceProxy) SendToCareProviderPatients(ctx *titan.Context, request *SendToCareProviderPatientsRequest) (*MessageResponse, error) {
	return srv.service.SendToCareProviderPatients(ctx, request)
}
func (srv *SocketServiceProxy) SendToCareProviderMembers(ctx *titan.Context, request *SendToCareProviderMembersRequest) (*MessageResponse, error) {
	return srv.service.SendToCareProviderMembers(ctx, request)
}
func (srv *SocketServiceProxy) SendToDeviceWithResponse(ctx *titan.Context, request *SendToDeviceWithResponseRequest) (*SendToDeviceResponse, error) {
	return srv.service.SendToDeviceWithResponse(ctx, request)
}
func (srv *SocketServiceProxy) NotifySocketConnCreated(ctx *titan.Context, request *NotifySocketConnCreatedRequest) error {
	return srv.service.NotifySocketConnCreated(ctx, request)
}
func (srv *SocketServiceProxy) SendToClient(ctx *titan.Context, request *SendToClientRequest) (*MessageResponse, error) {
	return srv.service.SendToClient(ctx, request)
}

// Define service router -----------------------------------------------------------------
type SocketServiceRouter struct {
	proxy *SocketServiceProxy
}

func (router *SocketServiceRouter) Register(r titan.Router) {
	r.RegisterTopic(EVENT_SendEventToDevice, router.proxy.SendEventToDevice)
	r.RegisterTopic(LEGACY_TOPIC_SendEventToDevice, router.proxy.SendEventToDevice)
	r.RegisterTopic(EVENT_SendToDevice, router.proxy.SendToDevice)
	r.RegisterTopic(LEGACY_TOPIC_SendToDevice, router.proxy.SendToDevice)
	r.RegisterTopic(EVENT_SendToUser, router.proxy.SendToUser)
	r.RegisterTopic(LEGACY_TOPIC_SendToUser, router.proxy.SendToUser)
	r.RegisterTopic(EVENT_SendToUsers, router.proxy.SendToUsers)
	r.RegisterTopic(LEGACY_TOPIC_SendToUsers, router.proxy.SendToUsers)
	r.RegisterTopic(EVENT_SendToPatient, router.proxy.SendToPatient)
	r.RegisterTopic(LEGACY_TOPIC_SendToPatient, router.proxy.SendToPatient)
	r.RegisterTopic(EVENT_SendToCareProviderPatients, router.proxy.SendToCareProviderPatients)
	r.RegisterTopic(LEGACY_TOPIC_SendToCareProviderPatients, router.proxy.SendToCareProviderPatients)
	r.RegisterTopic(EVENT_SendToCareProviderMembers, router.proxy.SendToCareProviderMembers)
	r.RegisterTopic(LEGACY_TOPIC_SendToCareProviderMembers, router.proxy.SendToCareProviderMembers)
	r.RegisterTopic(EVENT_SendToDeviceWithResponse, router.proxy.SendToDeviceWithResponse)
	r.RegisterTopic(LEGACY_TOPIC_SendToDeviceWithResponse, router.proxy.SendToDeviceWithResponse)
	r.RegisterTopic(EVENT_NotifySocketConnCreated, router.proxy.NotifySocketConnCreated)
	r.RegisterTopic(LEGACY_TOPIC_NotifySocketConnCreated, router.proxy.NotifySocketConnCreated)
	r.RegisterTopic(EVENT_SendToClient, router.proxy.SendToClient)
	r.RegisterTopic(LEGACY_TOPIC_SendToClient, router.proxy.SendToClient)
}

// Subscriber
func (router *SocketServiceRouter) Subscribe(s *titan.MessageSubscriber) {
}

func NewSocketServiceRouter(s SocketService) *SocketServiceRouter {
	p := &SocketServiceProxy{s}
	return &SocketServiceRouter{p}
}

// Define client ----------------------------------------------------------------------------------------------
type SocketServiceClient struct {
	client *titan.Client
}

func (srv *SocketServiceClient) SendEventToDevice(ctx *titan.Context, request *SendEventToDeviceRequest) (*MessageResponse, error) {
	req, _ := titan.NewReqBuilder().
		Post(EVENT_SendEventToDevice).
		Subject(NATS_SUBJECT).
		BodyJSON(request).
		Build()
	var resp = &MessageResponse{}
	err := srv.client.SendAndReceiveJson(ctx, req, &resp)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
func (srv *SocketServiceClient) SendToDevice(ctx *titan.Context, request *SendToDeviceRequest) (*MessageResponse, error) {
	req, _ := titan.NewReqBuilder().
		Post(EVENT_SendToDevice).
		Subject(NATS_SUBJECT).
		BodyJSON(request).
		Build()
	var resp = &MessageResponse{}
	err := srv.client.SendAndReceiveJson(ctx, req, &resp)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
func (srv *SocketServiceClient) SendToUser(ctx *titan.Context, request *SendToUserRequest) (*MessageResponse, error) {
	req, _ := titan.NewReqBuilder().
		Post(EVENT_SendToUser).
		Subject(NATS_SUBJECT).
		BodyJSON(request).
		Build()
	var resp = &MessageResponse{}
	err := srv.client.SendAndReceiveJson(ctx, req, &resp)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
func (srv *SocketServiceClient) SendToUsers(ctx *titan.Context, request *SendToUsersRequest) (*SendToUsersResponse, error) {
	req, _ := titan.NewReqBuilder().
		Post(EVENT_SendToUsers).
		Subject(NATS_SUBJECT).
		BodyJSON(request).
		Build()
	var resp = &SendToUsersResponse{}
	err := srv.client.SendAndReceiveJson(ctx, req, &resp)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
func (srv *SocketServiceClient) SendToPatient(ctx *titan.Context, request *SendToPatientRequest) (*MessageResponse, error) {
	req, _ := titan.NewReqBuilder().
		Post(EVENT_SendToPatient).
		Subject(NATS_SUBJECT).
		BodyJSON(request).
		Build()
	var resp = &MessageResponse{}
	err := srv.client.SendAndReceiveJson(ctx, req, &resp)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
func (srv *SocketServiceClient) SendToCareProviderPatients(ctx *titan.Context, request *SendToCareProviderPatientsRequest) (*MessageResponse, error) {
	req, _ := titan.NewReqBuilder().
		Post(EVENT_SendToCareProviderPatients).
		Subject(NATS_SUBJECT).
		BodyJSON(request).
		Build()
	var resp = &MessageResponse{}
	err := srv.client.SendAndReceiveJson(ctx, req, &resp)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
func (srv *SocketServiceClient) SendToCareProviderMembers(ctx *titan.Context, request *SendToCareProviderMembersRequest) (*MessageResponse, error) {
	req, _ := titan.NewReqBuilder().
		Post(EVENT_SendToCareProviderMembers).
		Subject(NATS_SUBJECT).
		BodyJSON(request).
		Build()
	var resp = &MessageResponse{}
	err := srv.client.SendAndReceiveJson(ctx, req, &resp)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
func (srv *SocketServiceClient) SendToDeviceWithResponse(ctx *titan.Context, request *SendToDeviceWithResponseRequest) (*SendToDeviceResponse, error) {
	req, _ := titan.NewReqBuilder().
		Post(EVENT_SendToDeviceWithResponse).
		Subject(NATS_SUBJECT).
		BodyJSON(request).
		Build()
	var resp = &SendToDeviceResponse{}
	err := srv.client.SendAndReceiveJson(ctx, req, &resp)
	if err != nil {
		return nil, err
	}
	return resp, nil
}
func (srv *SocketServiceClient) NotifySocketConnCreated(ctx *titan.Context, request *NotifySocketConnCreatedRequest) error {
	req, _ := titan.NewReqBuilder().
		Post(EVENT_NotifySocketConnCreated).
		Subject(NATS_SUBJECT).
		BodyJSON(request).
		Build()
	_, err := srv.client.SendRequest(ctx, req)
	return err
}
func (srv *SocketServiceClient) SendToClient(ctx *titan.Context, request *SendToClientRequest) (*MessageResponse, error) {
	req, _ := titan.NewReqBuilder().
		Post(EVENT_SendToClient).
		Subject(NATS_SUBJECT).
		BodyJSON(request).
		Build()
	var resp = &MessageResponse{}
	err := srv.client.SendAndReceiveJson(ctx, req, &resp)
	if err != nil {
		return nil, err
	}
	return resp, nil
}

func NewSocketServiceClient(clients ...*titan.Client) *SocketServiceClient {
	var client *titan.Client
	if len(clients) <= 0 {
		client = titan.GetDefaultClient()
	} else {
		client = clients[0]
	}
	return &SocketServiceClient{client: client}
}

// Define event Notifier -----------------------------------------------------------------------------------------
type ApiNotifier struct {
	client *titan.Client
}

func NewApiNotifier() *ApiNotifier {
	client := titan.GetDefaultClient()
	return &ApiNotifier{client}
}

// -----------------------------------------------
// Test event listener
type ApiEventListener struct {
	mux sync.Mutex
}

func (listener *ApiEventListener) Reset() {
	listener.mux.Lock()
	listener.mux.Unlock()
}

// Test Subscribe to events
func (listener *ApiEventListener) Subscribe(s *titan.MessageSubscriber) {
}
